#pragma once

#include "BitStream.h"
#include "HuffmanCodeLengthTable.h"

#include <vector>
#include <string>


class HuffmanStream
{

public:
    HuffmanStream(BitStream* inputStream, BitStream* outputStream);

    bool decode();

    void generateFixedCodeMapping();

    void setCodeLengthAlphabetLengths(const std::vector<unsigned char>& lengths);

private:
    void readCodingsTable();

    void readLiteralCodeLengths();

    bool readNextCodeLengthSymbol(unsigned& buffer);

    BitStream* mInputStream;
    BitStream* mOutputStream;

    unsigned mNumLiterals{0}; // HLIT + 257
    unsigned mNumDistances{0}; // HDIST + 1

    bool mUsingFixedCodes{false};
    HuffmanCodeLengthTable mCodeLengthTable;

};
